#include "PD_ObjAttention.h"
#include "glog/logging.h"

using namespace ADC::PD_ObjAttention;
// using namespace ADC::PD_NodeUpdate;

void RiskObjAttention::ObjAttentionProc(const PD_SVEstmd::SVEstmd &svtrajpnt,
                                        const PD::PD_Input &pd_input,
                                        const PD_EgoVehTrj::EgoVehTrj &egovehtrj,
                                        const PD_DynmcObjRsk::DynamicObjRisk &dynmcobjrsk)

{
    if (ADC::PD_NodeUpdate::Init(egovehtrj, svtrajpnt) || (!egovehtrj.egoveh_tp.empty()))
    {
        // PD_ClsnSVObj pd_clsnsvobj;
        PD_AttentionSVObj pd_attentionobj;
        // float PD_Nodelat2reflindist = 0.5f; // lateral threshold of longitudinal collision,unit:m
        float PD_AttentionRelat_S = 0.6;

        std::vector<PD_AttentionSVObj> temp_PD_AttentionObjList;

        float TargetObjSizeWid = 0.0f;

        for (auto it = svtrajpnt.SV_Trajectory_list.begin(); it != svtrajpnt.SV_Trajectory_list.end();) // get sv number
        {
            bool AttentionObj_LatRsk_TrgEnbl = false;
            uint32_t attentionobjid = (*it).m_obj_ID;
            // NodeUpdate

            TargetObjSizeWid = ADC::PD_NodeUpdate::GetObjSizeWidth(attentionobjid, pd_input);
            // DLOG(INFO) << "half_egowid: " << 0.5 * EgoVheSizeWidth
            //            << "\tobjid: " << int(objid)
            //            << "\thalf_TargetobjWid: " << 0.5 * TargetObjSizeWid
            //            << std::endl;

            int sv_size = it->pd_ls_point_list.size();
            int ev_size = egovehtrj.egoveh_tp.size();
            int IntermNum = std::min(sv_size, ev_size);

            for (int i = 0; i < IntermNum; i++)
            {
                // DLOG(INFO) << std::endl;
                // DLOG(INFO) << "old_l: " << fabs(it->pd_ls_point_list[i].l)
                //            << "\tNew_l: " << fabs(it->pd_ls_point_list[i].l - egovehtrj.egoveh_tp[i].l) - 0.5 * EgoVheSizeWidth - 0.5 * TargetObjSizeWid
                //            << std::endl;
                if ((fabs(it->pd_ls_point_list[i].l - egovehtrj.egoveh_tp[i].l) - 0.5 * EgoVheSizeWidth - 0.5 * TargetObjSizeWid) <= PD_AttentionRelat_S)
                {
                    AttentionObj_LatRsk_TrgEnbl = true;
                    break;
                }
            }

            if (AttentionObj_LatRsk_TrgEnbl == true)
            {
                pd_attentionobj.m_ObjID = (*it).m_obj_ID;
                for (int i = 0; i < IntermNum; i++)
                {

                    pd_attentionobj.vec_l.emplace_back((*it).pd_ls_point_list[i].l);
                    pd_attentionobj.vec_relat_s.emplace_back((*it).pd_ls_point_list[i].s_relative);

                    // calculate related object ttc
                    // foreach dynmcobjsk obj id
                    for (int j = 0; j < dynmcobjrsk.m_DynObjRsk_list.size(); j++)
                    {
                        if (pd_attentionobj.m_ObjID == dynmcobjrsk.m_DynObjRsk_list[j].ObjID)
                        {
                            // foreach member in ttc/td

                            // int ttc_size = dynmcobjrsk.m_DynObjRsk_list[j].m_ObjLongPreClsnTTC.size();
                            // int td_size = dynmcobjrsk.m_DynObjRsk_list[j].m_ObjLongPreClsnTD.size();
                            // int Num = std::min(ttc_size, td_size);
                            // for (int m = 0; m < Num; m++)
                            // {
                            //     pd_attentionobj.vec_ttc.emplace_back(dynmcobjrsk.m_DynObjRsk_list[j].m_ObjLongPreClsnTTC[m]);
                            //     pd_attentionobj.vec_DistTm.emplace_back(dynmcobjrsk.m_DynObjRsk_list[j].m_ObjLongPreClsnTD[m]);
                            // }
                            pd_attentionobj.vec_DistTm.emplace_back(dynmcobjrsk.m_DynObjRsk_list[j].m_ObjLongPreClsnTTC[i]);
                            pd_attentionobj.vec_ttc.emplace_back(dynmcobjrsk.m_DynObjRsk_list[j].m_ObjLongPreClsnTTC[i]);
                        }
                    }
                    temp_PD_AttentionObjList.emplace_back(pd_attentionobj);
                }

                // DLOG(INFO) << "temp_attsize: " << temp_PD_AttentionObjList.size() << std::endl;

                pd_attentionobj.vec_l.clear();
                pd_attentionobj.vec_relat_s.clear();
                pd_attentionobj.vec_DistTm.clear();
                pd_attentionobj.vec_ttc.clear();
                // PD_AttentionObjList.clear();

                PD_AttentionObjList.emplace_back(temp_PD_AttentionObjList.back()); // fill with latrisk object
                // PD_AttentionObjList
            }

            temp_PD_AttentionObjList.clear();
            it++;
        }

        if (PD_AttentionObjList.size() >= static_cast<int>(1))
        {
#ifdef GLOG
            // analysis data
            DLOG(INFO) << "before_Att_latrisknum: " << PD_AttentionObjList.size() << std::endl;
            for (auto ele : PD_AttentionObjList)
            {
                DLOG(INFO) << "before_Att_obj_id: " << ele.m_ObjID << std::endl;
            }
#endif

            // add sourrding vechiel initial l constraints
            for (auto iter = PD_AttentionObjList.begin(); iter != PD_AttentionObjList.end();)
            {
                //     // check sv initial l position
                bool temp_Flg = false;
                for (int i = 0; i < iter->vec_l.size(); i++)
                {
                    if (fabs(iter->vec_l.front()) >= (SVInitalFrnt_L + 0.2))
                    {
                        temp_Flg = true;
                        break;
                    }
                }
                if (temp_Flg == true)
                    PD_AttentionObjList.erase(iter);
                else
                    iter++;
            }
        }

        if (!PD_AttentionObjList.empty())
        {
#ifdef GLOG
            // analysis data
            DLOG(INFO) << "after_Att_latrisknum: " << PD_AttentionObjList.size() << std::endl;
            for (auto ele : PD_AttentionObjList)
            {
                DLOG(INFO) << "after_Att_obj_id: " << ele.m_ObjID << std::endl;
            }
#endif

            uint32_t AttentionObjID = 0;

            float PD_AttentionObjRltvDist = 20.0f; // unit:m

            float PD_AttentionTTCIvld_ThrsVal = 20.0f;
            float PD_AttentionTD_ThrsVal = 0.8f;
            float PD_AttentionTTC_EnblVal = 2.8f;

            PD::ObjAttention temp_objattention;

            for (int RltvObj_idx = 0; RltvObj_idx < PD_AttentionObjList.size(); RltvObj_idx++) // relative object number
            {
                // temp_objattention.m_obj_attention.obj_id = PD_AttentionObjList[RltvObj_idx].m_ObjID;
                attention.obj_id = PD_AttentionObjList[RltvObj_idx].m_ObjID;
#ifdef GLOG
                DLOG(INFO) << "attobj num: " << PD_AttentionObjList.size() << std::endl;
                DLOG(INFO) << RltvObj_idx << "\tid: " << int(attention.obj_id)
                           << "\tmin_s: "
                           << fabs(*min_element(PD_AttentionObjList.at(RltvObj_idx).vec_relat_s.begin(), PD_AttentionObjList.at(RltvObj_idx).vec_relat_s.end())) << std::endl;
                DLOG(INFO) << std::endl;
#endif
                if ((AttentionVehSpdEnblProc(PD_AttentionObjList[RltvObj_idx].m_ObjID, pd_input)) &&
                    (fabs(*min_element(PD_AttentionObjList.at(RltvObj_idx).vec_relat_s.begin(), PD_AttentionObjList.at(RltvObj_idx).vec_relat_s.end())) < PD_AttentionObjRltvDist))
                {
                    if (*min_element(PD_AttentionObjList[RltvObj_idx].vec_ttc.begin(), PD_AttentionObjList[RltvObj_idx].vec_ttc.end()) > PD_AttentionTTCIvld_ThrsVal) // handle small Speed difference case
                    {
                        if (fabs(*min_element(PD_AttentionObjList[RltvObj_idx].vec_DistTm.begin(), PD_AttentionObjList[RltvObj_idx].vec_DistTm.end())) <= PD_AttentionTD_ThrsVal)
                        {
                            AttentionObjTrgEnbl = true;
                        }
                    }
                    else if (fabs(*min_element(PD_AttentionObjList[RltvObj_idx].vec_ttc.begin(), PD_AttentionObjList[RltvObj_idx].vec_ttc.end())) < PD_AttentionTTC_EnblVal)
                    {
                        AttentionObjTrgEnbl = true;
                    }
                }
                else
                {
                    AttentionObjTrgEnbl = false;
                }
                DLOG(INFO) << RltvObj_idx << "\tobj id: " << int(attention.obj_id)
                           << "\tAttentionObjTrgEnbl: " << AttentionObjTrgEnbl << std::endl;
                DLOG(INFO) << std::endl;

                // attention flg link bahavior
                if (AttentionBahvirEnblProc(pd_input))
                {
                    attention.obj_attention_flg = (AttentionObjTrgEnbl && AttentionBahvirEnblProc(pd_input));
                }
                else
                {
                    attention.obj_attention_flg = false;
                }

                // link related passage id
                attention.passage_id.x = pd_input.rm_roadmodel.at(rm_Num).passage_list.at(psg_Num).passage_id.x;
                attention.passage_id.y = pd_input.rm_roadmodel.at(rm_Num).passage_list.at(psg_Num).passage_id.y;

                if (attention.obj_attention_flg)
                {
                    attention.obj_attention_grade = static_cast<uint8_t>(1);
                }

                objattention.emplace_back(attention);
            }

            // erase attention flg false object
            if (!objattention.empty())
            {
                // DLOG(INFO) << "before obj att num: " << objattention.size() << std::endl;
                for (auto it = objattention.begin(); it != objattention.end();)
                {
                    bool Invalid_AttTrgEnbl = false;
                    if (it->obj_attention_flg == false)
                    {
                        Invalid_AttTrgEnbl = true;
                    }
                    if (Invalid_AttTrgEnbl)
                    {
                        objattention.erase(it);
                    }
                    else
                        it++;
                }
                // DLOG(INFO) << "after obj att num: " << objattention.size() << std::endl;
            }
            if (!objattention.empty())
            {

                // analysis attention obj data
#ifdef GLOG
                // for (auto ele : objattention)
                // {
                //     DLOG(INFO) << "att_id: " << ele.obj_id
                //                << "\tonly_att_flg: " << ele.obj_attention_flg
                //                << std::endl;
                // }
#endif
                // cout dynamic assessment item
                for (int i = 0; i < objattention.size(); i++)
                {
                    for (auto ele : PD_AttentionObjList)
                    {
                        float siwid = ADC::PD_NodeUpdate::GetObjSizeWidth(ele.m_ObjID, pd_input);
#ifdef GLOG
                        // if (objattention[i].obj_id == ele.m_ObjID)
                        // {
                        //     DLOG(INFO) << std::endl;
                        //     DLOG(INFO) << "att_id: " << ele.m_ObjID << std::endl;
                        //     for (int k = 0; k < ele.vec_DistTm.size(); k++)
                        //     {
                        //         DLOG(INFO) << "att_td: " << ele.vec_DistTm[k]
                        //                    << "\tatt_ttc: " << ele.vec_ttc[k]
                        //                    << "\tatt_s: " << ele.vec_relat_s[k]
                        //                    << "\tatt_l: " << ele.vec_l[k]
                        //                    << "\teogveh_l: " << egovehtrj.egoveh_tp[k].l
                        //                    << "\tsiwid: " << 0.5 * siwid
                        //                    << "\tatt_relat_l: " << fabs(ele.vec_l[k] - egovehtrj.egoveh_tp[k].l) - 0.5 * EgoVheSizeWidth - 0.5 * siwid
                        //                    << std::endl;
                        //     }
                        // }
#endif
                    }
                }
            }
        }
    }
}

bool RiskObjAttention::AttObjRiskStsProc(float &ttc, float &td, float &lgtdist)
{
    bool AttObjRiskEnbl = false;
    if (fabs(lgtdist) <= 5.5)
    {
        AttObjRiskEnbl = true;
    }
    if (fabs(ttc) <= 2.5)
    {
        AttObjRiskEnbl = true;
    }
    if (fabs(td) <= 0.5)
    {
        AttObjRiskEnbl = true;
    }

    return AttObjRiskEnbl;
}

void RiskObjAttention::UpdateObjAttentionProc(const PD_SVEstmd::SVEstmd &svtrajpnt,
                                              const PD::PD_Input &pd_input,
                                              const PD_EgoVehTrj::EgoVehTrj &egovehtrj,
                                              const PD_DynmcObjRsk::DynamicObjRisk &dynmcobjrsk)
{
    if (ADC::PD_NodeUpdate::Init(egovehtrj, svtrajpnt) || (!egovehtrj.egoveh_tp.empty()))
    {

        PD_AttObjInfo pd_attobjinfo;
        if (!dynmcobjrsk.m_DynObjRsk_list.empty())
        {
            // float ObjAtt_MinTTC = 999;
            pd_attobjinfo_vec.clear();
            int cnt = 0;

            for (auto iter = dynmcobjrsk.m_DynObjRsk_list.begin(); iter != dynmcobjrsk.m_DynObjRsk_list.end();)
            {

                int dynmcsize = std::min((*iter).m_ObjLongPreClsnTD.size(), (*iter).m_ObjLongPreClsnTTC.size());
                for (int i = 0; i < dynmcsize; i++)
                {
                    pd_attobjinfo.m_ObjID = (*iter).ObjID;
                    pd_attobjinfo.MinTTC = *min_element((*iter).m_ObjLongPreClsnTTC.begin(), (*iter).m_ObjLongPreClsnTTC.end());
                    pd_attobjinfo.MinTD = *min_element((*iter).m_ObjLongPreClsnTD.begin(), (*iter).m_ObjLongPreClsnTD.end());
                    pd_attobjinfo.MinLgtDist = (*iter).m_ObjLongMinDis;
                }

                // analysis data
                
                // DLOG(INFO) << cnt+1 << "\tid: " << int(pd_attobjinfo.m_ObjID)
                //            << "\tmin_ttc: " << pd_attobjinfo.MinTTC
                //            << "\tmin_td: " << pd_attobjinfo.MinTD
                //            << "\tmin_s: " << pd_attobjinfo.MinLgtDist;
                pd_attobjinfo.Risksts = AttObjRiskStsProc(pd_attobjinfo.MinTTC, pd_attobjinfo.MinTD, pd_attobjinfo.MinLgtDist);
                pd_attobjinfo_vec.emplace_back(pd_attobjinfo);
                iter++;
                cnt++;
            }
        }

        // to get the highest risk obj info
        std::vector<PD_AttObjInfo> risk_attobjinfo;
        PD_AttObjInfo HighRiskObj;
        if (!pd_attobjinfo_vec.empty())
        {
            for (int m = 0; m < pd_attobjinfo_vec.size(); m++)
            {

                if (AttentionBahvirEnblProc(pd_input) && AttentionVehSpdEnblProc(pd_attobjinfo_vec[m].m_ObjID, pd_input) &&
                    (pd_attobjinfo_vec[m].Risksts == true))
                {
                    attention.obj_attention_flg = true;
                    attention.obj_attention_grade = uint8_t(1);
                    attention.obj_id = pd_attobjinfo_vec[m].m_ObjID;
                }
                else
                {
                    attention.obj_attention_flg = false;
                    attention.obj_attention_grade = uint8_t(0);
                    attention.obj_id = pd_attobjinfo_vec[m].m_ObjID;
                }
                // link related passage id
                attention.passage_id.x = pd_input.rm_roadmodel.at(rm_Num).passage_list.at(psg_Num).passage_id.x;
                attention.passage_id.y = pd_input.rm_roadmodel.at(rm_Num).passage_list.at(psg_Num).passage_id.y;
                objattention.emplace_back(attention);
            }
        }
    }

#ifdef GLOG
    // analysis data

    // for (auto it = dynmcobjrsk.m_DynObjRsk_list.begin(); it != dynmcobjrsk.m_DynObjRsk_list.end();)
    // {
    //     DLOG(INFO) << "id: " << int(it->ObjID)
    //                << "\taction: " << int(pd_input.rm_roadmodel.at(rm_Num).passage_list.at(psg_Num).action_type);
    //     int datasz = std::min(it->m_ObjLongPreClsnTD.size(), it->m_ObjLongPreClsnTTC.size());
    //     for (int i = 0; i < datasz; i++)
    //     {
    //         DLOG(INFO) << i << "\tttc: " << it->m_ObjLongPreClsnTTC[i]
    //                    << "\ttd: " << it->m_ObjLongPreClsnTD[i];
    //     }
    //     it++;
    // }
    // DLOG(INFO) << std::endl;

    // // analysis data

    // for (auto iter = svtrajpnt.SV_Trajectory_list.begin(); iter != svtrajpnt.SV_Trajectory_list.end();)
    // {
    //     DLOG(INFO) << "obj id: " << int(iter->m_obj_ID)
    //                << "\taction: " << int(pd_input.rm_roadmodel.at(rm_Num).passage_list.at(psg_Num).action_type);

    //     float objwidth = ADC::PD_NodeUpdate::GetObjSizeWidth(iter->m_obj_ID, pd_input);

    //     for (int i = 0; i < iter->pd_ls_point_list.size(); i++)
    //     {
    //         DLOG(INFO) << "re obj_s: " << iter->pd_ls_point_list[i].s_relative
    //                    << "\tobj_l: " << iter->pd_ls_point_list[i].l
    //                    << "\tre_obj_l: " << fabs(iter->pd_ls_point_list[i].l - egovehtrj.egoveh_tp[i].l) - 0.5 * EgoVheSizeWidth - 0.5 * objwidth
    //                    << "\tvx: " << iter->pd_ls_point_list[i].vs
    //                    << "\tvl: " << iter->pd_ls_point_list[i].vl;
    //     }
    //     iter++;
    //     DLOG(INFO) << std::endl;
    // }

#endif
}

bool RiskObjAttention::AttentionBahvirEnblProc(const PD::PD_Input &pd_input)
{
    bool AttentionActTypeEnbl = false;
    // DLOG(INFO) << "psg size: " << pd_input.rm_roadmodel.at(rm_Num).passage_list.size() << std::endl;
    if ((pd_input.rm_roadmodel.at(rm_Num).passage_list.at(psg_Num).action_type == BA::BA_ActionTyp::BA_ActionTyp_LeftLaneChange && (pd_input.rm_roadmodel.at(rm_Num).passage_list.size() == 1)) ||
        (pd_input.rm_roadmodel.at(rm_Num).passage_list.at(psg_Num).action_type == BA::BA_ActionTyp::BA_ActionTyp_RightLaneChange && (pd_input.rm_roadmodel.at(rm_Num).passage_list.size() == 1)) /* ||
         pd_input.rm_roadmodel.at(rm_Num).passage_list.at(psg_Num).action_type == BA::BA_ActionTyp::BA_ActionTyp_LeftLaneChangeAbolition ||
         pd_input.rm_roadmodel.at(rm_Num).passage_list.at(psg_Num).action_type == BA::BA_ActionTyp::BA_ActionTyp_RightLaneChangeAbolition*/
    )

    {
        AttentionActTypeEnbl = true;
    }

    return AttentionActTypeEnbl;
}

bool RiskObjAttention::AttentionVehSpdEnblProc(const uint32_t targetobjid,
                                               const PD::PD_Input &pd_input)
{
    float egovehspd = pd_input.VSE_LgtVehSpd;
    float targetobjspd = 0.0f;
    float SpdValConstraint = 8.3; // speed value:30km/h

    for (auto eleobj : pd_input.rm_roadmodel.at(rm_Num).object_list)
    {
        if (targetobjid == eleobj.object_id)
        {
            targetobjspd = eleobj.absolute_velocity_x;
            break;
        }
    }
    if ((egovehspd >= SpdValConstraint) && (targetobjspd >= SpdValConstraint))
    {
        Attention_VehSpdEnbl = true;
    }

    return Attention_VehSpdEnbl;
}

void RiskObjAttention::Process(const PD_SVEstmd::SVEstmd &svtrajpnt,
                               const PD::PD_Input &pd_input,
                               const PD_EgoVehTrj::EgoVehTrj &egovehtrj,
                               const PD_DynmcObjRsk::DynamicObjRisk &dynmcobjrsk)
{
    if (pd_input.rm_roadmodel.at(rm_Num).road_id.x == static_cast<uint8_t>(0) &&
        pd_input.rm_roadmodel.at(rm_Num).road_id.y == static_cast<uint8_t>(0))
        UpdateObjAttentionProc(svtrajpnt, pd_input, egovehtrj, dynmcobjrsk);
}